Index: Singular/mpr_base.cc
===================================================================
--- Singular/mpr_base.cc	(revision 0f5091ea1879ab5dca9d221f9cfc0b248090d973)
+++ Singular/mpr_base.cc	(revision e858e7474c86dc4faa76dde10fcfb590dcdaabae)
@@ -1351,11 +1460,14 @@
   srand((long)(((int)time(tp) % MAXSEED)+MAXSEED*18));
 
-  while ( i <= dim ) {
+  while ( i <= dim )
+  {
     shift[i]= (mprfloat) (RVMULT*rand()/(RAND_MAX+1.0));
     i++;
-    for ( j= 1; j < i-1; j++ ) {
-      if ( (shift[j] < shift[i-1] + SIMPLEX_EPS) && (shift[j] > shift[i-1] - SIMPLEX_EPS) ) {
-	i--;
-	break;
+    for ( j= 1; j < i-1; j++ )
+    {
+      if ( (shift[j] < shift[i-1] + SIMPLEX_EPS) && (shift[j] > shift[i-1] - SIMPLEX_EPS) )
+      {
+        i--;
+        break;
       }
     }
@@ -1373,8 +1485,11 @@
   vs= new pointSet( dim );
 
-  for ( j= 1; j <= Q1->num; j++ ) {
-    for ( k= 1; k <= Q2->num; k++ ) {
-      for ( l= 1; l <= dim; l++ ) {
-	vert.point[l]= (*Q1)[j]->point[l] + (*Q2)[k]->point[l];
+  for ( j= 1; j <= Q1->num; j++ )
+  {
+    for ( k= 1; k <= Q2->num; k++ )
+    {
+      for ( l= 1; l <= dim; l++ )
+      {
+        vert.point[l]= (*Q1)[j]->point[l] + (*Q2)[k]->point[l];
       }
       vs->mergeWithExp( &vert );
@@ -1397,5 +1512,6 @@
   for ( j= 1; j <= pQ[0]->num; j++ ) vs->addPoint( (*pQ[0])[j] );
 
-  for ( j= 1; j < numq; j++ ) {
+  for ( j= 1; j < numq; j++ )
+  {
     vs_old= vs;
     vs= minkSumTwo( vs_old, pQ[j], dim );
@@ -1419,6 +1535,7 @@
   mprfloat shift[MAXVARS+2];   // shiftvector delta, index [1..dim]
 
-  if ( pVariables > MAXVARS ) {
-    Werror("resMatrixSparse::resMatrixSparse: To many variables!");
+  if ( pVariables > MAXVARS )
+  {
+    WerrorS("resMatrixSparse::resMatrixSparse: To many variables!");
     return;
   }
@@ -1447,6 +1564,7 @@
 
   // need AllocAligned since we allocate mem for type double
-  LP.LiPM = (mprfloat **)Alloc( LP.LiPM_rows * sizeof(mprfloat *) );  // LP matrix 
-  for( i= 0; i < LP.LiPM_rows; i++ ) {
+  LP.LiPM = (mprfloat **)Alloc( LP.LiPM_rows * sizeof(mprfloat *) );  // LP matrix
+  for( i= 0; i < LP.LiPM_rows; i++ )
+  {
     // Mem must be allocated aligned, also for type double!
     LP.LiPM[i] = (mprfloat *)AllocAligned0( LP.LiPM_cols * sizeof(mprfloat) );
@@ -1475,5 +1593,5 @@
 
 #ifdef mprMINKSUM
-  E= minkSumAll( Qi, n+1, n);  
+  E= minkSumAll( Qi, n+1, n);
 #else
   // get inner points
@@ -1487,5 +1605,6 @@
 #endif
   Print("\n E = (Q_0 + ... + Q_n) \\cap \\N :\n");
-  for ( pnt= 1; pnt <= E->num; pnt++ ) {
+  for ( pnt= 1; pnt <= E->num; pnt++ )
+  {
     Print("%d: <",pnt);print_exp( (*E)[pnt], E->dim );Print(">\n");
   }
@@ -1495,6 +1614,6 @@
 #ifdef mprTEST
   int lift[5][5];
-  lift[0][1]=3; lift[0][2]=4; lift[0][3]=8;  lift[0][4]=2; 
-  lift[1][1]=6; lift[1][2]=1; lift[1][3]=7;  lift[1][4]=4; 
+  lift[0][1]=3; lift[0][2]=4; lift[0][3]=8;  lift[0][4]=2;
+  lift[1][1]=6; lift[1][2]=1; lift[1][3]=7;  lift[1][4]=4;
   lift[2][1]=2; lift[2][2]=5; lift[2][3]=9;  lift[2][4]=6;
   lift[3][1]=2; lift[3][2]=1; lift[3][3]=9;  lift[3][4]=5;
@@ -1510,5 +1629,6 @@
 
   // run Row Content Function for every point in E
-  for ( pnt= 1; pnt <= E->num; pnt++ ) {
+  for ( pnt= 1; pnt <= E->num; pnt++ )
+  {
     RC( Qi, E, pnt, shift );
   }
@@ -1516,6 +1636,8 @@
   // remove points not in cells
   k= E->num;
-  for ( pnt= k; pnt > 0; pnt-- ) {
-    if ( (*E)[pnt]->rcPnt == NULL ) {
+  for ( pnt= k; pnt > 0; pnt-- )
+  {
+    if ( (*E)[pnt]->rcPnt == NULL )
+    {
       E->removePoint(pnt);
       mprSTICKYPROT(ST_SPARSE_RCRJ);
@@ -1526,5 +1648,6 @@
 #ifdef mprDEBUG_PROT
   Print(" points which lie in a cell:\n");
-  for ( pnt= 1; pnt <= E->num; pnt++ ) {
+  for ( pnt= 1; pnt <= E->num; pnt++ )
+  {
     Print("%d: <",pnt);print_exp( (*E)[pnt], E->dim );Print(">\n");
   }
@@ -1539,5 +1662,6 @@
 #ifdef mprDEBUG_PROT
   Print(" points with a[ij] (%d):\n",E->num);
-  for ( pnt= 1; pnt <= E->num; pnt++ ) {
+  for ( pnt= 1; pnt <= E->num; pnt++ )
+  {
     Print("Punkt p \\in E[%d]: <",pnt);print_exp( (*E)[pnt], E->dim );
     Print(">, RC(p) = (i:%d, j:%d), a[i,j] = <",(*E)[pnt]->rc.set,(*E)[pnt]->rc.pnt);
@@ -1548,8 +1672,9 @@
 
   // now create matrix
-  if ( createMatrix( E ) != E->num ) {
+  if ( createMatrix( E ) != E->num )
+  {
     // this can happen if the shiftvector shift is to large or not generic
     istate= resMatrixBase::fatalError;
-    Werror("resMatrixSparse::resMatrixSparse: Error in resMatrixSparse::createMatrix!");
+    WerrorS("resMatrixSparse::resMatrixSparse: Error in resMatrixSparse::createMatrix!");
     goto theEnd;
     //return;
@@ -1558,5 +1683,6 @@
  theEnd:
   // clean up
-  for ( i= 0; i < idelem; i++ ) {
+  for ( i= 0; i < idelem; i++ )
+  {
     delete Qi[i];
   }
@@ -1565,9 +1691,10 @@
   delete E;
 
-  for( i= 0; i < LP.LiPM_rows; i++ ) {
+  for( i= 0; i < LP.LiPM_rows; i++ )
+  {
     FreeAligned( (ADDRESS) LP.LiPM[i], LP.LiPM_cols * sizeof(mprfloat) );
     //    Free( (ADDRESS) LP.LiPM[i], LP.LiPM_cols * sizeof(mprfloat) );
   }
-  Free( (ADDRESS) LP.LiPM, LP.LiPM_rows * sizeof(mprfloat *) );	
+  Free( (ADDRESS) LP.LiPM, LP.LiPM_rows * sizeof(mprfloat *) );
 
   Free( (ADDRESS) LP.iposv, (idelem * MAXPOINTS) * sizeof(int) );
@@ -1592,5 +1719,6 @@
 
   // now fill in coeffs of f0
-  for ( i= 1; i <= numSet0; i++ ) {
+  for ( i= 1; i <= numSet0; i++ )
+  {
 
     pgls= (gls->m)[0]; // f0
@@ -1605,14 +1733,18 @@
     // u_1,..,u_k
     cp=2;
-    while ( pNext(pgls) ) {
+    while ( pNext(pgls) )
+    {
       phelp= pOne();
       pSetCoeff( phelp, nCopy(pGetCoeff(pgls)) );
       pSetComp( phelp, IMATELEM(*uRPos,i,cp) );
-      if ( piter ) {
-	pNext(piter)= phelp;
-	piter= phelp;
-      } else {
-	pp= phelp;
-	piter= phelp;
+      if ( piter )
+      {
+        pNext(piter)= phelp;
+        piter= phelp;
+      }
+      else
+      {
+        pp= phelp;
+        piter= phelp;
       }
       cp++;
@@ -1643,5 +1775,6 @@
   mprPROTnl("smCallDet");
 
-  for ( i= 1; i <= numSet0; i++ ) {
+  for ( i= 1; i <= numSet0; i++ )
+  {
     pp= (rmat->m)[IMATELEM(*uRPos,i,1)];
     pDelete( &pp );
@@ -1650,16 +1783,21 @@
     piter= NULL;
     // u_1,..,u_n
-    for ( cp= 2; cp <= idelem; cp++ ) {
-      if ( !nIsZero(evpoint[cp-1]) ) {
-	phelp= pOne();
-	pSetCoeff( phelp, nCopy(evpoint[cp-1]) );
-	pSetComp( phelp, IMATELEM(*uRPos,i,cp) );
-	if ( piter ) {
-	  pNext(piter)= phelp;
-	  piter= phelp;
-	} else {
-	  pp= phelp;
-	  piter= phelp;
-	}
+    for ( cp= 2; cp <= idelem; cp++ )
+    {
+      if ( !nIsZero(evpoint[cp-1]) )
+      {
+        phelp= pOne();
+        pSetCoeff( phelp, nCopy(evpoint[cp-1]) );
+        pSetComp( phelp, IMATELEM(*uRPos,i,cp) );
+        if ( piter )
+        {
+          pNext(piter)= phelp;
+          piter= phelp;
+        }
+        else
+        {
+          pp= phelp;
+          piter= phelp;
+        }
       }
     }
@@ -1695,5 +1833,6 @@
   mprPROTnl("smCallDet");
 
-  for ( i= 1; i <= numSet0; i++ ) {
+  for ( i= 1; i <= numSet0; i++ )
+  {
     pp= (rmat->m)[IMATELEM(*uRPos,i,1)];
     pDelete( &pp );
@@ -1702,15 +1841,19 @@
     piter= NULL;
     for ( cp= 2; cp <= idelem; cp++ ) { // u1 .. un
-      if ( !nIsZero(evpoint[cp-1]) ) {
-	phelp= pOne();
-	pSetCoeff( phelp, nCopy(evpoint[cp-1]) );
-	pSetComp( phelp, IMATELEM(*uRPos,i,cp) );
-	if ( piter ) {
-	  pNext(piter)= phelp;
-	  piter= phelp;
-	} else {
-	  pp= phelp;
-	  piter= phelp;
-	}
+      if ( !nIsZero(evpoint[cp-1]) )
+      {
+        phelp= pOne();
+        pSetCoeff( phelp, nCopy(evpoint[cp-1]) );
+        pSetComp( phelp, IMATELEM(*uRPos,i,cp) );
+        if ( piter )
+        {
+          pNext(piter)= phelp;
+          piter= phelp;
+        }
+        else
+        {
+          pp= phelp;
+          piter= phelp;
+        }
       }
     }
@@ -1748,5 +1891,5 @@
    * _gls: system of multivariate polynoms
    * special: -1 -> resMatrixDense is a symbolic matrix
-   *    0,1, ... -> resMatrixDense ist eine u-Resultante, wobei special das 
+   *    0,1, ... -> resMatrixDense ist eine u-Resultante, wobei special das
    *                        lineare u-Polynom angibt
    */
@@ -1774,5 +1917,5 @@
    */
   const number getSubDet();
-  
+
 private:
   /** deactivated copy constructor */
@@ -1789,5 +1932,5 @@
   void generateMonomData( int deg, intvec* polyDegs , intvec* iVO );
 
-  /** Recursively generate all homogeneous monoms of 
+  /** Recursively generate all homogeneous monoms of
    * pVariables variables of degree deg.
    */
@@ -1812,22 +1955,24 @@
 //<-
 
-//-> struct resVector 
+//-> struct resVector
 /* Holds a row vector of the dense resultant matrix */
 struct resVector
 {
 public:
-  void init() {
+  void init()
+  {
     isReduced = FALSE;
-    elementOfS = SFREE; 
+    elementOfS = SFREE;
     mon = NULL;
   }
-  void init( const poly m ) {
+  void init( const poly m )
+  {
     isReduced = FALSE;
-    elementOfS = SFREE; 
-    mon = m; 
+    elementOfS = SFREE;
+    mon = m;
   }
 
   /** index von 0 ... numVectors-1 */
-  poly getElem( const int i ); 
+  poly getElem( const int i );
 
   /** index von 0 ... numVectors-1 */
@@ -1842,14 +1987,14 @@
   int elementOfS;
 
-  /** holds the index of u0, u1, ..., un, if (elementOfS == linPolyS) 
-   *  the size is given by pVariables 
+  /** holds the index of u0, u1, ..., un, if (elementOfS == linPolyS)
+   *  the size is given by pVariables
    */
-  int *numColParNr;        
+  int *numColParNr;
 
   /** holds the column vector if (elementOfS != linPolyS) */
-  number *numColVector;   
+  number *numColVector;
 
   /** size of numColVector */
-  int numColVectorSize;   
+  int numColVectorSize;
 
   number *numColVecCopy;
@@ -1859,10 +2004,10 @@
 //-> resVector::*
 poly resVector::getElem( const int i ) // inline ???
-{ 
+{
   assume( 0 < i || i > numColVectorSize );
   poly out= pOne();
   pSetCoeff( out, numColVector[i] );
   pTest( out );
-  return( out ); 
+  return( out );
 }
 
@@ -1870,5 +2015,5 @@
 {
   assume( i >= 0 && i < numColVectorSize );
-  return( numColVector[i] ); 
+  return( numColVector[i] );
 }
 //<-
@@ -1877,7 +2022,7 @@
 resMatrixDense::resMatrixDense( const ideal _gls, const int special )
   : resMatrixBase()
-{ 
+{
   int i;
-  
+
   sourceRing=currRing;
   gls= idCopy( _gls );
@@ -1886,8 +2031,9 @@
 
   // init all
-  generateBaseData(); 
+  generateBaseData();
 
   totDeg= 1;
-  for ( i= 0; i < IDELEMS(gls); i++ ) {
+  for ( i= 0; i < IDELEMS(gls); i++ )
+  {
     totDeg*=pTotaldegree( (gls->m)[i] );
   }
@@ -1897,26 +2043,28 @@
   istate= resMatrixBase::ready;
 }
- 
+
 resMatrixDense::~resMatrixDense()
 {
   int i,j;
-  for (i=0; i < numVectors; i++) 
-    {
-      pDelete( &resVectorList[i].mon );
-      pDelete( &resVectorList[i].dividedBy );
-      for ( j=0; j < resVectorList[i].numColVectorSize; j++ ) {
-	nDelete( resVectorList[i].numColVector+j );
-      }
-      Free( (ADDRESS)resVectorList[i].numColVector, numVectors*sizeof( number ) );
-      Free( (ADDRESS)resVectorList[i].numColParNr, (pVariables+1) * sizeof(int) );
-    }
-  
+  for (i=0; i < numVectors; i++)
+  {
+    pDelete( &resVectorList[i].mon );
+    pDelete( &resVectorList[i].dividedBy );
+    for ( j=0; j < resVectorList[i].numColVectorSize; j++ )
+    {
+        nDelete( resVectorList[i].numColVector+j );
+    }
+    Free( (ADDRESS)resVectorList[i].numColVector, numVectors*sizeof( number ) );
+    Free( (ADDRESS)resVectorList[i].numColParNr, (pVariables+1) * sizeof(int) );
+  }
+
   Free( (ADDRESS)resVectorList, veclistmax*sizeof( resVector ) );
 
-  // free matrix m 
-  if ( m != NULL ) {
+  // free matrix m
+  if ( m != NULL )
+  {
     for ( i= 1; i <= numVectors; i++ )
       for ( j= 1; j <= numVectors; j++ )
-	pDelete( &MATELEM(m , i, j) );
+        pDelete( &MATELEM(m , i, j) );
     Free( (ADDRESS)m->m, numVectors * numVectors * sizeof(poly) );
     Free( (ADDRESS)m, sizeof(ip_smatrix) );
@@ -1931,42 +2079,53 @@
   int k,i,j;
   resVector *vecp;
-  
+
   m= mpNew( numVectors, numVectors );
-  
-  for ( i= 1; i <= MATROWS( m ); i++ ) 
-    for ( j= 1; j <= MATCOLS( m ); j++ ) {
+
+  for ( i= 1; i <= MATROWS( m ); i++ )
+    for ( j= 1; j <= MATCOLS( m ); j++ )
+    {
       MATELEM(m,i,j)= pInit();
       pSetCoeff0( MATELEM(m,i,j), nInit(0) );
     }
-  
-
-  for ( k= 0; k <= numVectors - 1; k++ ) {
-    if ( linPolyS == getMVector(k)->elementOfS ) {
+
+
+  for ( k= 0; k <= numVectors - 1; k++ )
+  {
+    if ( linPolyS == getMVector(k)->elementOfS )
+    {
       mprSTICKYPROT(ST_DENSE_FR);
-      for ( i= 0; i < pVariables; i++ ) {
-	MATELEM(m,numVectors-k,numVectors-(getMVector(k)->numColParNr)[i])= pInit();
-      }
-    } else {
+      for ( i= 0; i < pVariables; i++ )
+      {
+        MATELEM(m,numVectors-k,numVectors-(getMVector(k)->numColParNr)[i])= pInit();
+      }
+    }
+    else
+    {
       mprSTICKYPROT(ST_DENSE_NR);
       vecp= getMVector(k);
-      for ( i= 0; i < numVectors; i++) 
-	if ( !nIsZero( vecp->getElemNum(i) ) ) {
-	  MATELEM(m,numVectors - k,i + 1)= pInit();
-	  pSetCoeff( MATELEM(m,numVectors - k,i + 1), nCopy(vecp->getElemNum(i)) );
-	}
+      for ( i= 0; i < numVectors; i++)
+        if ( !nIsZero( vecp->getElemNum(i) ) )
+        {
+          MATELEM(m,numVectors - k,i + 1)= pInit();
+          pSetCoeff( MATELEM(m,numVectors - k,i + 1), nCopy(vecp->getElemNum(i)) );
+        }
     }
   } // for
   mprSTICKYPROT("\n");
-  
+
 #ifdef mprDEBUG_ALL
-  for ( k= numVectors - 1; k >= 0; k-- ) 
-    if ( linPolyS == getMVector(k)->elementOfS ) {
-      for ( i=0; i < pVariables; i++ ) {
-	Print(" %d ",(getMVector(k)->numColParNr)[i]);
+  for ( k= numVectors - 1; k >= 0; k-- )
+    if ( linPolyS == getMVector(k)->elementOfS )
+    {
+      for ( i=0; i < pVariables; i++ )
+      {
+        Print(" %d ",(getMVector(k)->numColParNr)[i]);
       }
       PrintLn();
     }
-  for (i=1; i <= numVectors; i++) {
-    for (j=1; j <= numVectors; j++ ) {
+  for (i=1; i <= numVectors; i++)
+  {
+    for (j=1; j <= numVectors; j++ )
+    {
       pWrite0(MATELEM(m,i,j));Print("  ");
     }
@@ -1984,12 +2143,13 @@
     poly mon = pCopy( m );
     pSetm( mon );
-	
-    if ( numVectors == veclistmax ) {
-      resVectorList= (resVector * )ReAlloc( resVectorList, 
-					    (veclistmax) * sizeof( resVector ),
-					    (veclistmax + veclistblock) * sizeof( resVector ) );
+
+    if ( numVectors == veclistmax )
+    {
+      resVectorList= (resVector * )ReAlloc( resVectorList,
+                                            (veclistmax) * sizeof( resVector ),
+                                            (veclistmax + veclistblock) * sizeof( resVector ) );
       int k;
-      for ( k= veclistmax; k < (veclistmax + veclistblock); k++ ) 
-	resVectorList[k].init();
+      for ( k= veclistmax; k < (veclistmax + veclistblock); k++ )
+        resVectorList[k].init();
       veclistmax+= veclistblock;
       mprSTICKYPROT(ST_DENSE_MEM);
@@ -1998,10 +2158,13 @@
     resVectorList[numVectors].init( mon );
     numVectors++;
-    mprSTICKYPROT(ST_DENSE_NMON); 
+    mprSTICKYPROT(ST_DENSE_NMON);
     return;
-  } else {
+  }
+  else
+  {
     if ( var == pVariables+1 ) return;
     poly newm = pCopy( m );
-    while ( deg >= 0 ) {
+    while ( deg >= 0 )
+    {
       generateMonoms( newm, var+1, deg );
       pIncrExp( newm, var );
@@ -2011,5 +2174,5 @@
     pDelete( & newm );
   }
-  
+
   return;
 }
@@ -2023,10 +2186,10 @@
   veclistmax= veclistblock;
   resVectorList= (resVector *)Alloc( veclistmax*sizeof( resVector ) );
-  
+
   // Init resVector()s
   for ( j= veclistmax - 1; j >= 0; j-- ) resVectorList[j].init();
   numVectors= 0;
 
-  // Generate all monoms of degree deg  
+  // Generate all monoms of degree deg
   poly start= pOne();
   generateMonoms( start, 1, deg );
@@ -2034,10 +2197,11 @@
 
   mprSTICKYPROT("\n");
-  
+
   // Check for reduced monoms
   // First generate polyDegs.rows() monoms
   //  x(k)^(polyDegs[k]),  0 <= k < polyDegs.rows()
   ideal pDegDiv= idInit( polyDegs->rows(), 1 );
-  for ( k= 0; k < polyDegs->rows(); k++ ) {
+  for ( k= 0; k < polyDegs->rows(); k++ )
+  {
     poly p= pOne();
     pSetExp( p, k + 1, (*polyDegs)[k] );
@@ -2050,41 +2214,49 @@
   // exactly one x(k)^(polyDegs[k]) that divides the monom.
   int divCount;
-  for ( j= numVectors - 1; j >= 0; j-- ) {
+  for ( j= numVectors - 1; j >= 0; j-- )
+  {
     divCount= 0;
-    for ( k= 0; k < IDELEMS(pDegDiv); k++ ) 
-      if ( pDivisibleBy2( (pDegDiv->m)[k], resVectorList[j].mon ) ) 
-	divCount++;
+    for ( k= 0; k < IDELEMS(pDegDiv); k++ )
+      if ( pDivisibleBy2( (pDegDiv->m)[k], resVectorList[j].mon ) )
+        divCount++;
     resVectorList[j].isReduced= (divCount == 1);
   }
 
   // create the sets S(k)s
-  // a monom x(i)^deg, deg given, is element of the set S(i) 
+  // a monom x(i)^deg, deg given, is element of the set S(i)
   // if all x(0)^(polyDegs[0]) ... x(i-1)^(polyDegs[i-1]) DONT divide
   // x(i)^deg and only x(i)^(polyDegs[i]) divides x(i)^deg
   bool doInsert;
-  for ( k= 0; k < iVO->rows(); k++) {
+  for ( k= 0; k < iVO->rows(); k++)
+  {
     //mprPROTInl(" ------------ var:",(*iVO)[k]);
-    for ( j= numVectors - 1; j >= 0; j-- ) {
+    for ( j= numVectors - 1; j >= 0; j-- )
+    {
       //mprPROTPnl("testing monom",resVectorList[j].mon);
-      if ( resVectorList[j].elementOfS == SFREE ) {
-	//mprPROTnl("\tfree");
-	if ( pDivisibleBy2( (pDegDiv->m)[ (*iVO)[k] ], resVectorList[j].mon ) ) {
-	  //mprPROTPnl("\tdivisible by ",(pDegDiv->m)[ (*iVO)[k] ]);
-	  doInsert=TRUE;
-	  for ( i= 0; i < k; i++ ) {
-	    //mprPROTPnl("\tchecking db ",(pDegDiv->m)[ (*iVO)[i] ]);
-	    if ( pDivisibleBy2( (pDegDiv->m)[ (*iVO)[i] ], resVectorList[j].mon ) ) {
-	      //mprPROTPnl("\t and divisible by",(pDegDiv->m)[ (*iVO)[i] ]);
-	      doInsert=FALSE;
-	      break;
-	    } 
-	  }
-	  if ( doInsert ) {
-	    //mprPROTInl("\t------------------> S ",(*iVO)[k]);
-	    resVectorList[j].elementOfS= (*iVO)[k];
-	    resVectorList[j].dividedBy= pCopy( (pDegDiv->m)[ (*iVO)[i] ] );
-	    pSetm( resVectorList[j].dividedBy );
-	  }
-	}
+      if ( resVectorList[j].elementOfS == SFREE )
+      {
+        //mprPROTnl("\tfree");
+        if ( pDivisibleBy2( (pDegDiv->m)[ (*iVO)[k] ], resVectorList[j].mon ) )
+        {
+          //mprPROTPnl("\tdivisible by ",(pDegDiv->m)[ (*iVO)[k] ]);
+          doInsert=TRUE;
+          for ( i= 0; i < k; i++ )
+          {
+            //mprPROTPnl("\tchecking db ",(pDegDiv->m)[ (*iVO)[i] ]);
+            if ( pDivisibleBy2( (pDegDiv->m)[ (*iVO)[i] ], resVectorList[j].mon ) )
+            {
+              //mprPROTPnl("\t and divisible by",(pDegDiv->m)[ (*iVO)[i] ]);
+              doInsert=FALSE;
+              break;
+            }
+          }
+          if ( doInsert )
+          {
+            //mprPROTInl("\t------------------> S ",(*iVO)[k]);
+            resVectorList[j].elementOfS= (*iVO)[k];
+            resVectorList[j].dividedBy= pCopy( (pDegDiv->m)[ (*iVO)[i] ] );
+            pSetm( resVectorList[j].dividedBy );
+          }
+        }
       }
     }
@@ -2095,7 +2267,8 @@
   subSize= 0;
   int sub;
-  for ( i= 0; i < polyDegs->rows(); i++ ) {
+  for ( i= 0; i < polyDegs->rows(); i++ )
+  {
     sub= 1;
-    for ( k= 0; k < polyDegs->rows(); k++ ) 
+    for ( k= 0; k < polyDegs->rows(); k++ )
       if ( i != k ) sub*= (*polyDegs)[k];
     subSize+= sub;
@@ -2109,9 +2282,10 @@
   // Print a list of monoms and their properties
   Print("// \n");
-  for ( j= numVectors - 1; j >= 0; j-- ) {
+  for ( j= numVectors - 1; j >= 0; j-- )
+  {
     Print("// %s, S(%d),  db ",
-	  resVectorList[j].isReduced?"reduced":"nonreduced",
-	  resVectorList[j].elementOfS);
-    pWrite0(resVectorList[j].dividedBy); 
+          resVectorList[j].isReduced?"reduced":"nonreduced",
+          resVectorList[j].elementOfS);
+    pWrite0(resVectorList[j].dividedBy);
     Print("  monom ");
     pWrite(resVectorList[j].mon);
@@ -2136,16 +2310,21 @@
   // make sure that the homogenization variable goes last!
   intvec iVO( pVariables );
-  if ( linPolyS != SNONE ) {
+  if ( linPolyS != SNONE )
+  {
     iVO[pVariables - 1]= linPolyS;
     int p=0;
-    for ( k= pVariables - 1; k >= 0; k-- ) {
-      if ( k != linPolyS ) {
-	iVO[p]= k;
-	p++;
-      }
-    }
-  } else { 
+    for ( k= pVariables - 1; k >= 0; k-- )
+    {
+      if ( k != linPolyS )
+      {
+        iVO[p]= k;
+        p++;
+      }
+    }
+  }
+  else
+  {
     linPolyS= 0;
-    for ( k= 0; k < pVariables; k++ ) 
+    for ( k= 0; k < pVariables; k++ )
       iVO[k]= pVariables - k - 1;
   }
@@ -2161,6 +2340,8 @@
 
   // generate "matrix"
-  for ( k= numVectors - 1; k >= 0; k-- ) {
-    if ( resVectorList[k].elementOfS != linPolyS ) {
+  for ( k= numVectors - 1; k >= 0; k-- )
+  {
+    if ( resVectorList[k].elementOfS != linPolyS )
+    {
       // column k is a normal column with numerical or symbolic entries
       // init stuff
@@ -2177,23 +2358,26 @@
 
       // fill in "matrix"
-      while ( pi ) {
-	matEntry= nCopy(pGetCoeff(pi));
-	pmatchPos= pHead0( pi );
-	pSetCoeff( pmatchPos, nInit(1) );
-	pSetm( pmatchPos );
-
-	for ( i= 0; i < numVectors; i++) 
-	  if ( pEqual( pmatchPos, resVectorList[i].mon ) )
-	    break;
-
-	resVectorList[k].numColVector[numVectors - i - 1] = nCopy(matEntry);
-
-	pDelete( &pmatchPos );
-	nDelete( &matEntry );
-
-	pIter( pi );
+      while ( pi )
+      {
+        matEntry= nCopy(pGetCoeff(pi));
+        pmatchPos= pHead0( pi );
+        pSetCoeff( pmatchPos, nInit(1) );
+        pSetm( pmatchPos );
+
+        for ( i= 0; i < numVectors; i++)
+          if ( pEqual( pmatchPos, resVectorList[i].mon ) )
+            break;
+
+        resVectorList[k].numColVector[numVectors - i - 1] = nCopy(matEntry);
+
+        pDelete( &pmatchPos );
+        nDelete( &matEntry );
+
+        pIter( pi );
       }
       pDelete( &pi );
-    } else {
+    }
+    else
+    {
       // column is a special column, i.e. is generated by S0 and F0
       // safe only the positions of the ui's in the column
@@ -2209,15 +2393,15 @@
       j=0;
       while ( pi ) { // fill in "matrix"
-	pmp= pMult( pHead( pi ), pCopy( factor ) );
-	pSetm( pmp );pTest( pi );
-
-	for ( i= 0; i < numVectors; i++) 
-	  if ( pEqual( pmp, resVectorList[i].mon ) )
-	    break;
-
-	resVectorList[k].numColParNr[j]= i;
-	pDelete( &pmp );
-	pIter( pi );
-	j++;
+        pmp= pMult( pHead( pi ), pCopy( factor ) );
+        pSetm( pmp );pTest( pi );
+
+        for ( i= 0; i < numVectors; i++)
+          if ( pEqual( pmp, resVectorList[i].mon ) )
+            break;
+
+        resVectorList[k].numColParNr[j]= i;
+        pDelete( &pmp );
+        pIter( pi );
+        j++;
       }
       pDelete( &pi );
@@ -2233,35 +2417,44 @@
 }
 
-resVector *resMatrixDense::getMVector(int i) 
-{ 
+resVector *resMatrixDense::getMVector(int i)
+{
   assume( i >= 0 && i < numVectors );
-  return &resVectorList[i]; 
+  return &resVectorList[i];
 }
 
 const ideal resMatrixDense::getMatrix()
-{ 
+{
   int k,i,j;
 
   // copy matrix
   matrix resmat= mpNew(numVectors,numVectors);
-  for (i=1; i <= numVectors; i++) {
-    for (j=1; j <= numVectors; j++ ) {
-      if ( MATELEM(m,i,j) && pGetCoeff(MATELEM(m,i,j)) ) {
-	MATELEM(resmat,i,j)= pCopy( MATELEM(m,i,j) );
-      }
-    }
-  }
-  for (i=0; i < numVectors; i++) {
-    if ( resVectorList[i].elementOfS == linPolyS ) {
-      for (j=1; j <= pVariables; j++ ) {
-	if ( MATELEM(resmat,numVectors-i,numVectors-resVectorList[i].numColParNr[j-1]) ) 
-	  pDelete( &MATELEM(resmat,numVectors-i,numVectors-resVectorList[i].numColParNr[j-1]) );
-	MATELEM(resmat,numVectors-i,numVectors-resVectorList[i].numColParNr[j-1])= pOne();
-	// FIX ME
-	if ( true ) {
-	  pSetCoeff( MATELEM(resmat,numVectors-i,numVectors-resVectorList[i].numColParNr[j-1]), nPar(j) );
-	} else {
-	  pSetExp( MATELEM(resmat,numVectors-i,numVectors-resVectorList[i].numColParNr[j-1]), j, 1 );
-	}
+  for (i=1; i <= numVectors; i++)
+  {
+    for (j=1; j <= numVectors; j++ )
+    {
+      if ( MATELEM(m,i,j) && pGetCoeff(MATELEM(m,i,j)) )
+      {
+        MATELEM(resmat,i,j)= pCopy( MATELEM(m,i,j) );
+      }
+    }
+  }
+  for (i=0; i < numVectors; i++)
+  {
+    if ( resVectorList[i].elementOfS == linPolyS )
+    {
+      for (j=1; j <= pVariables; j++ )
+      {
+        if ( MATELEM(resmat,numVectors-i,numVectors-resVectorList[i].numColParNr[j-1]) )
+          pDelete( &MATELEM(resmat,numVectors-i,numVectors-resVectorList[i].numColParNr[j-1]) );
+        MATELEM(resmat,numVectors-i,numVectors-resVectorList[i].numColParNr[j-1])= pOne();
+        // FIX ME
+        if ( true )
+        {
+          pSetCoeff( MATELEM(resmat,numVectors-i,numVectors-resVectorList[i].numColParNr[j-1]), nPar(j) );
+        }
+        else
+        {
+          pSetExp( MATELEM(resmat,numVectors-i,numVectors-resVectorList[i].numColParNr[j-1]), j, 1 );
+        }
       }
     }
@@ -2270,8 +2463,9 @@
   ideal resmod= idMatrix2Module(resmat);
 
-  if ( resmat != NULL ) {
+  if ( resmat != NULL )
+  {
     for ( i= 1; i <= numVectors; i++ )
       for ( j= 1; j <= numVectors; j++ )
-	pDelete( &MATELEM(resmat , i, j) );
+        pDelete( &MATELEM(resmat , i, j) );
     Free( (ADDRESS)resmat->m, numVectors * numVectors * sizeof(poly) );
     Free( (ADDRESS)resmat, sizeof(ip_smatrix) );
@@ -2290,25 +2484,29 @@
 
   j=1;
-  for ( k= numVectors - 1; k >= 0; k-- ) {
+  for ( k= numVectors - 1; k >= 0; k-- )
+  {
     vecp= getMVector(k);
     if ( vecp->isReduced ) continue;
     l=1;
-    for ( i= numVectors - 1; i >= 0; i-- ) {
+    for ( i= numVectors - 1; i >= 0; i-- )
+    {
       if ( getMVector(i)->isReduced ) continue;
-      if ( !nIsZero(vecp->getElemNum(numVectors - i - 1)) ) {
-	MATELEM(resmat,j,l)= pInit();
-	MATELEM(resmat,j,l)= pCopy( vecp->getElem(numVectors-i-1) );
+      if ( !nIsZero(vecp->getElemNum(numVectors - i - 1)) )
+      {
+        MATELEM(resmat,j,l)= pInit();
+        MATELEM(resmat,j,l)= pCopy( vecp->getElem(numVectors-i-1) );
       }
       l++;
     }
     j++;
-  } 
+  }
 
   ideal resmod= idMatrix2Module(resmat);
 
-  if ( resmat != NULL ) {
+  if ( resmat != NULL )
+  {
     for ( i= 1; i <= numVectors; i++ )
       for ( j= 1; j <= numVectors; j++ )
-	pDelete( &MATELEM(resmat , i, j) );
+        pDelete( &MATELEM(resmat , i, j) );
     Free( (ADDRESS)resmat->m, numVectors * numVectors * sizeof(poly) );
     Free( (ADDRESS)resmat, sizeof(ip_smatrix) );
@@ -2324,9 +2522,12 @@
   // copy evaluation point into matrix
   // p0, p1, ..., pn replace u0, u1, ..., un
-  for ( k= numVectors - 1; k >= 0; k-- ) {
-    if ( linPolyS == getMVector(k)->elementOfS ) {
-      for ( i= 0; i < pVariables; i++ ) {
-	pSetCoeff( MATELEM(m,numVectors-k,numVectors-(getMVector(k)->numColParNr)[i]), 
-		   nCopy(evpoint[i]) );
+  for ( k= numVectors - 1; k >= 0; k-- )
+  {
+    if ( linPolyS == getMVector(k)->elementOfS )
+    {
+      for ( i= 0; i < pVariables; i++ )
+      {
+        pSetCoeff( MATELEM(m,numVectors-k,numVectors-(getMVector(k)->numColParNr)[i]),
+                   nCopy(evpoint[i]) );
       }
     }
@@ -2340,11 +2541,14 @@
   // avoid errors for det==0
   number numres;
-  if ( res && pGetCoeff( res ) ) {
+  if ( res && pGetCoeff( res ) )
+  {
     numres= nCopy( pGetCoeff( res ) );
-  } else {
+  }
+  else
+  {
     numres= nInit(0);
     mprPROT("0");
   }
-  pDelete( &res );  
+  pDelete( &res );
 
   mprSTICKYPROT(ST__DET);
@@ -2361,6 +2565,8 @@
   matrix mat= mpNew( subSize, subSize );
 
-  for ( i= 1; i <= MATROWS( mat ); i++ ) {
-    for ( j= 1; j <= MATCOLS( mat ); j++ ) {
+  for ( i= 1; i <= MATROWS( mat ); i++ )
+  {
+    for ( j= 1; j <= MATCOLS( mat ); j++ )
+    {
       MATELEM(mat,i,j)= pInit();
       pSetCoeff0( MATELEM(mat,i,j), nInit(0) );
@@ -2368,29 +2574,37 @@
   }
   j=1;
-  for ( k= numVectors - 1; k >= 0; k-- ) {
+  for ( k= numVectors - 1; k >= 0; k-- )
+  {
     vecp= getMVector(k);
     if ( vecp->isReduced ) continue;
     l=1;
-    for ( i= numVectors - 1; i >= 0; i-- ) {
+    for ( i= numVectors - 1; i >= 0; i-- )
+    {
       if ( getMVector(i)->isReduced ) continue;
-      if ( vecp->getElemNum(numVectors - i - 1) && !nIsZero(vecp->getElemNum(numVectors - i - 1)) ) {
-	pSetCoeff(MATELEM(mat, j , l ), nCopy(vecp->getElemNum(numVectors - i - 1)));
-      } /* else {
-	   MATELEM(mat, j , l )= pOne();
-	   pSetCoeff(MATELEM(mat, j , l ), nInit(0) );
-	   }
-	*/
+      if ( vecp->getElemNum(numVectors - i - 1) && !nIsZero(vecp->getElemNum(numVectors - i - 1)) )
+      {
+        pSetCoeff(MATELEM(mat, j , l ), nCopy(vecp->getElemNum(numVectors - i - 1)));
+      }
+      /* else
+      {
+           MATELEM(mat, j , l )= pOne();
+           pSetCoeff(MATELEM(mat, j , l ), nInit(0) );
+      }
+      */
       l++;
     }
     j++;
-  } 
+  }
 
   poly res= singclap_det( mat );
 
   number numres;
-  if ( res && pGetCoeff( res ) ) {
+  if ( res && pGetCoeff( res ) )
+  {
     numres= nCopy(pGetCoeff( res ));
-    pDelete( &res );    
-  } else {
+    pDelete( &res );
+  }
+  else
+  {
     numres= nInit(0);
   }
@@ -2416,5 +2630,5 @@
   mpz_init(md);mpz_set_ui(md,1);
   mpz_init(mn);mpz_set_ui(mn,1);
- 
+
   mpz_fac_ui(m,n+d);
   mpz_fac_ui(md,d);
@@ -2436,13 +2650,15 @@
 uResultant::uResultant( const ideal _gls, const resMatType _rmt, BOOLEAN extIdeal )
   : rmt( _rmt )
-{ 
-  if ( extIdeal ) {
+{
+  if ( extIdeal )
+  {
     // extend given ideal by linear poly F0=u0x0 + u1x1 +...+ unxn
     gls= extendIdeal( _gls, linearPoly( rmt ), rmt );
     n= IDELEMS( gls );
-  } else 
+  } else
     gls= idCopy( _gls );
 
-  switch ( rmt ) {
+  switch ( rmt )
+  {
   case sparseResMat:
     resMat= new resMatrixSparse( gls );
@@ -2452,5 +2668,5 @@
     break;
   default:
-    Werror("uResultant::uResultant: Unknown resultant matrix type choosen!");
+    WerrorS("uResultant::uResultant: Unknown resultant matrix type choosen!");
   }
 }
@@ -2464,16 +2680,18 @@
 {
   ideal newGls= idCopy( gls );
-  newGls->m= (poly *)ReAlloc( newGls->m, 
-			      IDELEMS(gls) * sizeof(poly), 
-			      (IDELEMS(gls) + 1) * sizeof(poly) );
+  newGls->m= (poly *)ReAlloc( newGls->m,
+                              IDELEMS(gls) * sizeof(poly),
+                              (IDELEMS(gls) + 1) * sizeof(poly) );
   IDELEMS(newGls)++;
- 
-  switch ( rmt ) {
+
+  switch ( rmt )
+  {
   case sparseResMat:
   case denseResMat:
     {
       int i;
-      for ( i= IDELEMS(newGls)-1; i > 0; i-- ) {
-	newGls->m[i]= newGls->m[i-1];
+      for ( i= IDELEMS(newGls)-1; i > 0; i-- )
+      {
+        newGls->m[i]= newGls->m[i-1];
       }
       newGls->m[0]= linPoly;
@@ -2481,7 +2699,7 @@
     break;
   default:
-    Werror("uResultant::extendIdeal: Unknown resultant matrix type choosen!");
-  }
-      
+    WerrorS("uResultant::extendIdeal: Unknown resultant matrix type choosen!");
+  }
+
   return( newGls );
 }
@@ -2494,5 +2712,6 @@
   poly actlp, rootlp= newlp;
 
-  for ( i= 1; i <= pVariables; i++ ) {
+  for ( i= 1; i <= pVariables; i++ )
+  {
     actlp= newlp;
     pSetExp( actlp, i, 1 );
@@ -2504,5 +2723,6 @@
   pDelete( &newlp );
 
-  if ( rmt == sparseResMat ) {
+  if ( rmt == sparseResMat )
+  {
     newlp= pOne();
     actlp->next= newlp;
@@ -2524,5 +2744,5 @@
   // long mdg= (facul(tdg+n-1) / facul( tdg )) / facul( n - 1 );
   long mdg= over( n-1, tdg );
-  
+
   // maxiaml number of terms in a polynom of degree tdg
   long l=(long)pow( tdg+1, n );
@@ -2534,5 +2754,5 @@
 #endif
 
-  // we need mdg results of D(p0,p1,...,pn) 
+  // we need mdg results of D(p0,p1,...,pn)
   number *presults;
   presults= (number *)Alloc( mdg * sizeof( number ) );
@@ -2546,6 +2766,7 @@
   // initial evaluatoin point
   p=1;
-  for (i=0; i < n; i++) {
-    // init pevpoint with primes 3,5,7,11, ... 
+  for (i=0; i < n; i++)
+  {
+    // init pevpoint with primes 3,5,7,11, ...
     p= nextPrime( p );
     pevpoint[i]=nInit( p );
